ResizableField< Data_T > Class Template Reference
Fields

`#include <Field.h>`

Inheritance diagram for ResizableField< Data_T >:

## Public Types

typedef ResizableField< Data_T > | class_type
typedef boost::intrusive_ptr< ResizableField > | Ptr
Public Types inherited from WritableField< Data_T >
typedef WritableField< Data_T > | class_type
typedef boost::intrusive_ptr< WritableField > | Ptr
Public Types inherited from Field< Data_T >
typedef Field< Data_T > | class_type
typedef boost::intrusive_ptr< Field > | Ptr
typedef Data_T | value_type
| Allows us to reference the template class.
typedef std::vector< Ptr > | Vec
| This is a convenience typedef for the list that Field3DInputFile::readScalarLayers() and Field3DInputFile::readVectorLayers() will return its data in.
Public Types inherited from FieldRes
typedef FieldRes | class_type
typedef boost::intrusive_ptr< FieldRes > | Ptr
typedef std::vector< Ptr > | Vec
Public Types inherited from FieldBase
typedef FieldBase | class_type
typedef boost::intrusive_ptr< FieldBase > | Ptr
Public Types inherited from RefBase
typedef boost::intrusive_ptr< RefBase > | Ptr
typedef boost::weak_ptr< RefBase > | WeakPtr

## Public Member Functions

void | copyFrom (typename Field< Data_T >::Ptr other)
| Copies the data from another Field, also resizes.
template<class Data_T2>
void | copyFrom (typename Field< Data_T2 >::Ptr other)
| Copies the data from another Field of another template class, also resizes.
void | matchDefinition (FieldRes::Ptr fieldToMatch)
| Sets up this field so that resolution and mapping matches the other.
void | setSize (const Box3i &extents)
| Resizes the object.
void | setSize (const Box3i &extents, const Box3i &dataWindow)
| Resizes the object.
void | setSize (const V3i &size)
| Resizes the object.
void | setSize (const V3i &size, int padding)
| Resizes the object with padding.
Public Member Functions inherited from WritableField< Data_T >
iterator | begin ()
| Iterator to first element.
iterator | begin (const Box3i &subset)
| Iterator to first element of specific subset.
virtual void | clear (const Data_T &value)
| Clears all the voxels in the storage. Should be re-implemented by subclasses that can provide a more efficient version.
iterator | end ()
| Iterator pointing one element past the last valid one.
iterator | end (const Box3i &subset)
| Iterator pointing one element past the last valid one (for a subset).
virtual Data_T & | lvalue (int i, int j, int k)=0
| Write access to a voxel. The coordinates are global coordinates.
Public Member Functions inherited from Field< Data_T >
const_iterator | cbegin () const
| Const iterator to first element. "cbegin" matches the tr1 c++ standard.
const_iterator | cbegin (const Box3i &subset) const
| Const iterator to first element of specific subset.
const_iterator | cend () const
| Const iterator pointing one element past the last valid one.
const_iterator | cend (const Box3i &subset) const
| Const iterator pointing one element past the last valid one (for a subset).
virtual std::string | dataTypeString () const
virtual Data_T | value (int i, int j, int k) const =0
| Read access to a voxel. The coordinates are in integer voxel space .
virtual | ~Field ()
| Dtor.
Public Member Functions inherited from FieldRes
V3i const | dataResolution () const
const Box3i & | dataWindow () const
| Returns the data window. Any coordinate inside this window is safe to pass to value() in the Field subclass.
const Box3i & | extents () const
| Returns the extents of the data. This signifies the relevant area that the data exists over. However, the data window (below) may be smaller than the extents, in which case it is only safe to call value() for those coordinate inside the data window.
| FieldRes ()
| This constructor ensures that we have a valid mapping at all times.
| FieldRes (const FieldRes &src)
| Base class copy constructor.
bool | isInBounds (int i, int j, int k) const
| Returns true is the indicies are in bounds of the data window.
FieldMapping::Ptr | mapping ()
| Returns a pointer to the mapping.
const FieldMapping::Ptr | mapping () const
| Returns a pointer to the mapping.
virtual void | mappingChanged ()
| Tells the subclass that the mapping changed.
virtual long long int | memSize () const
| Returns the memory usage (in bytes).
void | setMapping (FieldMapping::Ptr mapping)
| Sets the field's mapping.
virtual size_t | voxelCount () const
| Counts the number of voxels. For most fields, this is just the volume of the data window, but sparse data structures can override this to return a better value.
Public Member Functions inherited from FieldBase
| FieldBase ()
| Constructor.
| FieldBase (const FieldBase &)
| Copy Constructor.
virtual | ~FieldBase ()
| Destructor.
virtual std::string | className () const =0
| Returns the class name of the object. Used by the class pool and when writing the data to disk.
virtual std::string | classType () const =0
| Returns the full class type string.
virtual Ptr | clone () const =0
| Returns a pointer to a copy of the field, pure virtual so ensure derived classes properly implement it.
FieldMetadata & | metadata ()
| accessor to the m_metadata class
const FieldMetadata & | metadata () const
| Read only access to the m_metadata class.
void | copyMetadata (const FieldBase &field)
| Copies the metadata from a second field.
Public Member Functions inherited from RefBase
void | ref () const
| Used by boost::intrusive_pointer.
size_t | refcnt ()
| Used by boost::intrusive_pointer.
void | unref () const
| Used by boost::intrusive_pointer.
WeakPtr | weakPtr () const
| RefBase ()
| RefBase (const RefBase &)
| Copy constructor.
RefBase & | operator= (const RefBase &)
| Assignment operator.
virtual | ~RefBase ()
| Destructor.
virtual bool | checkRTTI (const char *typenameStr)=0
| This function is only implemented by concrete classes and triggers the actual RTTI check through matchRTTI();.
bool | matchRTTI (const char *typenameStr)
| Performs a check to see if the given typename string matches this class' This needs to be implemented in -all- subclasses, even abstract ones.
Public Member Functions inherited from MetadataCallback
virtual void | metadataHasChanged (const std::string &)
| Alerts the callback holder that the metadata has changed.

## Static Public Member Functions

static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from WritableField< Data_T >
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from Field< Data_T >
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldRes
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldBase
static const char * | staticClassName ()
static const char * | staticClassType ()
static const char * | staticClassType ()

## Public Attributes

| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from WritableField< Data_T >
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from Field< Data_T >
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldRes
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldBase
std::string | attribute
| Optional name of the attribute the field represents.
std::string | name
| Optional name of the field.

## Protected Types

typedef WritableField< Data_T > | base
Protected Types inherited from FieldRes
typedef MatrixFieldMapping | default_mapping

## Protected Member Functions

virtual void | sizeChanged ()
| Subclasses should re-implement this if they need to perform memory allocations, etc. every time the size of the storage changes.

## Static Protected Attributes

static TemplatedFieldType< ResizableField< Data_T > > | ms_classType

## Additional Inherited Members

Protected Attributes inherited from FieldRes
Box3i | m_dataWindow
| Defines the area where data is allocated. This should be treated as a closed (i.e. inclusive) interval.
Box3i | m_extents
| Defines the extents of the the storage. This may be larger or smaller than the data window, and in the case where it is larger, care must be taken not to access voxels outside the data window. This should be treated as a closed (i.e. inclusive) interval.
FieldMapping::Ptr | m_mapping
| Pointer to the field's mapping.

## Detailed Description

template<class Data_T>
class ResizableField< Data_T >

This class adds the ability to resize the data storage object. Most Field subclasses will derive from this class. Only classes that cannot implement sizeChanged() in a reasonable manner should derive from Field or WritableField.

Definition at line 833 of file Field.h.

## Member Typedef Documentation

## Ptr

template<class Data_T>

typedef boost::intrusive_ptr<ResizableField> ResizableField< Data_T >::Ptr

Definition at line 840 of file Field.h.

## class_type

template<class Data_T>

typedef ResizableField<Data_T> ResizableField< Data_T >::class_type

Definition at line 844 of file Field.h.

## base

template<class Data_T>

typedef WritableField<Data_T> ResizableField< Data_T >::base

protected

Definition at line 894 of file Field.h.

## Member Function Documentation

## staticClassName()

template<class Data_T>

const char * ResizableField< Data_T >::staticClassName | ( |  | ) |

inline static

Definition at line 847 of file Field.h.

{
return "ResizableField";
}

## staticClassType()

template<class Data_T>

const char * ResizableField< Data_T >::staticClassType | ( |  | ) |

inline static

Definition at line 852 of file Field.h.

{
return ResizableField<Data_T>::ms_classType.name();
}
FieldBase::name
std::string name
Optional name of the field.
Definition Field.h:171
ResizableField
Definition Field.h:835

References ms_classType.

## setSize() [1/4]

template<class Data_T>

void ResizableField< Data_T >::setSize | ( | const V3i & | size | ) |

Resizes the object.

Warning
  Never call this from a constructor. It calls the virtual function sizeChanged().

Definition at line 913 of file Field.h.

{
assert(size.x >= 0);
assert(size.y >= 0);
assert(size.z >= 0);
Field<Data_T>::m_extents.min = V3i(0);
Field<Data_T>::m_extents.max = size - V3i(1);
Field<Data_T>::m_dataWindow = Field<Data_T>::m_extents;
// Tell subclasses that the size changed so they can update themselves.
sizeChanged();
}
V3i
Imath::V3i V3i
Definition SpiMathLib.h:71
ResizableField::sizeChanged
virtual void sizeChanged()
Subclasses should re-implement this if they need to perform memory allocations, etc....
Definition Field.h:901

References FieldRes::m_dataWindow, FieldRes::m_extents, and sizeChanged().

Referenced by convertCellCenteredToMAC(), copyFrom(), copyFrom(), matchDefinition(), Field3DInputFile::readProxyLayer(), Field3DInputFileHDF5::readProxyLayer(), and setSize().

## setSize() [2/4]

template<class Data_T>

void ResizableField< Data_T >::setSize | ( | const Box3i & | extents | ) |

Resizes the object.

Warning
  Never call this from a constructor. It calls the virtual function sizeChanged().

Definition at line 930 of file Field.h.

{
Field<Data_T>::m_extents = extents;
Field<Data_T>::m_dataWindow = extents;
// Tell subclasses that the size changed so they can update themselves.
sizeChanged();
}
FieldRes::extents
const Box3i & extents() const
Returns the extents of the data. This signifies the relevant area that the data exists over....
Definition Field.h:249

References FieldRes::extents(), FieldRes::m_dataWindow, FieldRes::m_extents, and sizeChanged().

## setSize() [3/4]

template<class Data_T>

void ResizableField< Data_T >::setSize | ( | const Box3i & | extents,
|  | const Box3i & | dataWindow )

Resizes the object.

Warning
  Never call this from a constructor. It calls the virtual function sizeChanged().

Definition at line 941 of file Field.h.

{
Field<Data_T>::m_extents = extents;
Field<Data_T>::m_dataWindow = dataWindow;
// Tell subclasses that the size changed so they can update themselves.
sizeChanged();
}
FieldRes::dataWindow
const Box3i & dataWindow() const
Returns the data window. Any coordinate inside this window is safe to pass to value() in the Field su...
Definition Field.h:253

References FieldRes::dataWindow(), FieldRes::extents(), FieldRes::m_dataWindow, FieldRes::m_extents, and sizeChanged().

## setSize() [4/4]

template<class Data_T>

void ResizableField< Data_T >::setSize | ( | const V3i & | size,
|  | int | padding )

Resizes the object with padding.

Warning
  Never call this from a constructor. It calls the virtual function sizeChanged().

Definition at line 953 of file Field.h.

{
assert(size.x >= 0);
assert(size.y >= 0);
assert(size.z >= 0);
assert(padding >= 0);
setSize(Box3i(V3i(0), size - V3i(1)),
Box3i(V3i(-padding), size + V3i(padding - 1)));
}
Box3i
Imath::Box3i Box3i
Definition SpiMathLib.h:77
ResizableField::setSize
void setSize(const V3i &size)
Resizes the object.
Definition Field.h:913

References setSize().

## copyFrom() [1/2]

template<class Data_T>

void ResizableField< Data_T >::copyFrom | ( | typename Field< Data_T >::Ptr | other | ) |

Copies the data from another Field, also resizes.

Definition at line 967 of file Field.h.

{
// Set mapping
FieldRes::setMapping(other->mapping());
// Set size to match
setSize(other->extents(), other->dataWindow());
// Copy over the data
typename base::iterator i = base::begin();
typename base::iterator end = base::end();
typename Field<Data_T>::const_iterator c = other->cbegin();
for (; i != end; ++i, ++c)
*i = *c;
}
FieldRes::setMapping
void setMapping(FieldMapping::Ptr mapping)
Sets the field's mapping.
Definition Field.h:347
FieldRes::mapping
FieldMapping::Ptr mapping()
Returns a pointer to the mapping.
Definition Field.h:263
Field::cbegin
const_iterator cbegin() const
Const iterator to first element. "cbegin" matches the tr1 c++ standard.
Definition Field.h:569
WritableField::iterator
Definition Field.h:704
WritableField::end
iterator end()
Iterator pointing one element past the last valid one.
Definition Field.h:802
WritableField::begin
iterator begin()
Iterator to first element.
Definition Field.h:779

References WritableField< Data_T >::begin(), Field< Data_T >::cbegin(), FieldRes::dataWindow(), WritableField< Data_T >::end(), FieldRes::extents(), FieldRes::mapping(), FieldRes::setMapping(), and setSize().

## copyFrom() [2/2]

template<class Data_T>
template<class Data_T2>

void ResizableField< Data_T >::copyFrom | ( | typename Field< Data_T2 >::Ptr | other | ) |

Copies the data from another Field of another template class, also resizes.

Definition at line 986 of file Field.h.

{
// Set mapping
FieldRes::setMapping(other->mapping());
// Set size to match
setSize(other->extents(), other->dataWindow());
// Copy over the data
typename base::iterator i = base::begin();
typename base::iterator end = base::end();
typename Field<Data_T2>::const_iterator c = other->cbegin();
for (; i != end; ++i, ++c)
*i = *c;
}

References WritableField< Data_T >::begin(), Field< Data_T >::cbegin(), FieldRes::dataWindow(), WritableField< Data_T >::end(), FieldRes::extents(), FieldRes::mapping(), FieldRes::setMapping(), and setSize().

## matchDefinition()

template<class Data_T>

void ResizableField< Data_T >::matchDefinition | ( | FieldRes::Ptr | fieldToMatch | ) |

Sets up this field so that resolution and mapping matches the other.

Definition at line 1003 of file Field.h.

{
setSize(fieldToMatch->extents(), fieldToMatch->dataWindow());
FieldRes::setMapping(fieldToMatch->mapping());
}

References FieldRes::setMapping(), and setSize().

Referenced by MACField< V3h >::copyMAC().

## sizeChanged()

template<class Data_T>

virtual void ResizableField< Data_T >::sizeChanged | ( |  | ) |

inline protected virtual

Subclasses should re-implement this if they need to perform memory allocations, etc. every time the size of the storage changes.

Note
  Make sure to call the base class version in subclasses!

Reimplemented in DenseField< Data_T >, DenseField< double >, DenseField< float >, DenseField< half >, DenseField< V3d >, DenseField< V3f >, DenseField< V3h >, MACField< Data_T >, MACField< V3d >, MACField< V3f >, MACField< V3h >, real_t< Data_T >, SparseField< Data_T >, SparseField< double >, SparseField< float >, SparseField< half >, SparseField< V3d >, SparseField< V3f >, and SparseField< V3h >.

Definition at line 901 of file Field.h.

{ base::m_mapping->setExtents(base::m_extents); }
FieldRes::m_extents
Box3i m_extents
Defines the extents of the the storage. This may be larger or smaller than the data window,...
Definition Field.h:307
FieldRes::m_mapping
FieldMapping::Ptr m_mapping
Pointer to the field's mapping.
Definition Field.h:312

References FieldRes::m_extents, and FieldRes::m_mapping.

Referenced by setSize(), setSize(), setSize(), DenseField< Data_T >::sizeChanged(), MACField< Data_T >::sizeChanged(), and SparseField< half >::sizeChanged().

## Member Data Documentation

## DEFINE_FIELD_RTTI_ABSTRACT_CLASS

template<class Data_T>

ResizableField< Data_T >::DEFINE_FIELD_RTTI_ABSTRACT_CLASS

Definition at line 845 of file Field.h.

## ms_classType

template<class Data_T>

TemplatedFieldType<ResizableField<Data_T> > ResizableField< Data_T >::ms_classType

static protected

Definition at line 890 of file Field.h.

Referenced by staticClassType().

The documentation for this class was generated from the following file:

- export/Field.h